Bug 790973 - [PATCHES] Bugs found in python-krbV-1.0.90-4.fc15 using gcc-with-cpychecker static analyzer
[PATCHES] Bugs found in python-krbV-1.0.90-4.fc15 using gcc-with-cpychecker s...
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: python-krbV (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Mike Bonnet
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
: Reopened
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-02-15 15:36 EST by Dave Malcolm
Modified: 2016-11-24 05:36 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 09:06:47 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
[PATCH 1/5] Context_cc_default: remove redundant lookup of krb5_context (1.01 KB, patch)
2012-04-11 14:30 EDT, Dave Malcolm
no flags Details | Diff
[PATCH 2/5] Context_rc_default: remove redundant lookup of krb5_context (1014 bytes, patch)
2012-04-11 14:30 EDT, Dave Malcolm
no flags Details | Diff
[PATCH 3/5] Context_kt_default: remove redundant lookup of krb5_context (1011 bytes, patch)
2012-04-11 14:30 EDT, Dave Malcolm
no flags Details | Diff
[PATCH 4/5] replace buggy PyCObject_AsVoidPtr() usage with helper functions (34.24 KB, patch)
2012-04-11 14:31 EDT, Dave Malcolm
no flags Details | Diff
[PATCH 5/5] introduce make_class helper function (9.52 KB, patch)
2012-04-11 14:31 EDT, Dave Malcolm
no flags Details | Diff

  None (edit)
Description Dave Malcolm 2012-02-15 15:36:48 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
python-krbV-1.0.90-4.fc15.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-02-15/python-krbV-1.0.90-4.fc15/

Although the bug in the top-most category ("Segfaults in normal paths") appears to be a false positive, every bug I've reviewed in the second category ("Reference leaks") appears to be a true memory leak, and every bug in the third category ("Segfaults within error-handling paths") appear to be genuine segfaults under low memory conditions.  The bugs in the remaining categories may well all be false positives though.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
python-krbV-1.0.90-4.fc15
gcc-python-plugin post-0.9 git 073d390de53ef52136bd90e5ac06f1ef833d047d running the checker in an *f16* chroot
Comment 1 Dave Malcolm 2012-02-15 15:39:57 EST
See also https://fedorahosted.org/python-krbV/ticket/1
Comment 2 Dave Malcolm 2012-04-11 14:30:00 EDT
Created attachment 576833 [details]
[PATCH 1/5] Context_cc_default: remove redundant lookup of  krb5_context
Comment 3 Dave Malcolm 2012-04-11 14:30:27 EDT
Created attachment 576834 [details]
[PATCH 2/5] Context_rc_default: remove redundant lookup of  krb5_context
Comment 4 Dave Malcolm 2012-04-11 14:30:53 EDT
Created attachment 576835 [details]
[PATCH 3/5] Context_kt_default: remove redundant lookup of  krb5_context
Comment 5 Dave Malcolm 2012-04-11 14:31:17 EDT
Created attachment 576836 [details]
[PATCH 4/5] replace buggy PyCObject_AsVoidPtr() usage with helper  functions
Comment 6 Dave Malcolm 2012-04-11 14:31:40 EDT
Created attachment 576837 [details]
[PATCH 5/5] introduce make_class helper function
Comment 7 Dave Malcolm 2012-04-11 14:38:40 EDT
This compiles, but I could use help with testing.

I've also uploaded my repo to github; the above changes are in the "cleanups" branch:
  https://github.com/davidmalcolm/python-krbV/tree/cleanups
Comment 8 Fedora End Of Life 2013-04-03 12:20:22 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 9 Fedora End Of Life 2015-01-09 12:00:31 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 10 Fedora End Of Life 2015-02-17 09:06:47 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 11 Jan Kurik 2015-07-15 11:11:33 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 12 Fedora End Of Life 2016-11-24 05:36:51 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Note You need to log in before you can comment on or make changes to this bug.